function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var axios = _interopDefault(require('axios'));
var Loader = _interopDefault(require('react-loader-spinner'));
require('react-loader-spinner/dist/loader/css/react-spinner-loader.css');

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

var apiURL = 'https://pls.senddots.com/api/invoice/get';
var pollTimings = {
  100: 1000,
  200: 1500,
  300: 2000,
  400: 2500,
  500: 3000,
  1000: 10000,
  2000: 25000
};

var DotsCheckout = /*#__PURE__*/function (_Component) {
  _inheritsLoose(DotsCheckout, _Component);

  function DotsCheckout(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _this.onSuccess = function () {
      clearInterval(_this.state.pollInvoiceStatusTimer);

      if (_this.props.onSuccess) {
        _this.props.onSuccess();
      }
    };

    _this.pollInvoiceStatus = function () {
      if (_this.state.pollCount in pollTimings) {
        if (pollTimings[_this.state.pollCount] !== _this.state.pollInterval) {
          _this.setState({
            pollInterval: pollTimings[_this.state.pollCount]
          });

          clearInterval(_this.state.pollInvoiceStatusTimer);

          _this.setState({
            pollInvoiceStatusTimer: setInterval(_this.pollInvoiceStatus, _this.state.pollInterval)
          });
        }
      }

      _this.setState({
        pollCount: _this.state.pollCount + 1
      });

      if (_this.state.errorCount > 20) {
        clearInterval(_this.state.pollInvoiceStatusTimer);

        if (_this.props.onError) {
          _this.props.onError();
        }
      }

      if (_this.props.invoiceID && _this.props.dotsClientID) {
        var token = btoa(_this.props.dotsClientID + ':');
        var headers = {
          'Authorization': "Basic " + token
        };
        axios.get(apiURL + '/' + _this.props.invoiceID, {
          headers: headers
        }).then(function (res) {
          res = res.data;

          if (res.success) {
            if (res.invoice.status === 'completed') {
              _this.onSuccess();
            } else if (res.invoice.status === 'expired') {
              clearInterval(_this.state.pollInvoiceStatusTimer);

              if (_this.props.onFailure) {
                _this.props.onFailure();
              }
            }
          } else {
            _this.setState({
              errorCount: _this.state.errorCount + 1
            });
          }
        }).catch(function (err) {
          console.error(err);

          _this.setState({
            errorCount: _this.state.errorCount + 1
          });
        });
      } else {
        console.log('Invoice ID or Client ID are not set');
        clearInterval(_this.state.pollInvoiceStatusTimer);
      }
    };

    _this.goToInvoice = function () {
      if (_this.props.invoiceURL) {
        window.open(_this.props.invoiceURL, '_blank');

        _this.setState({
          pollInvoiceStatusTimer: setInterval(_this.pollInvoiceStatus, _this.state.pollInterval)
        });
      } else {
        console.log('Invoice URL is not set');
      }
    };

    _this.state = {
      dotsClientID: props.dotsClientID,
      status: 'created',
      pollInvoiceStatusTimer: null,
      pollInterval: 500,
      pollCount: 0,
      errorCount: 0,
      buttonHover: false,
      discount: props.discount ? true : false
    };
    var img = new Image();
    img.src = 'https://www.senddots.com/img/logo.png';
    var img2 = new Image();
    img2.src = 'https://www.senddots.com/img/logo_dark.png';
    window.addEventListener('message', _this.handlePostMessage);
    return _this;
  }

  var _proto = DotsCheckout.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    clearInterval(this.state.pollInvoiceStatusTimer);
  };

  _proto.handlePostMessage = function handlePostMessage(event) {
    if (event.origin === 'https://senddots.com' && event.origin === 'https://www.senddots.com') {
      var data = JSON.parse(event.data);

      if (data.success) {
        this.onSuccess();
      }
    } else {
      return;
    }
  };

  _proto.render = function render() {
    var _this2 = this;

    var loading = this.props.invoiceURL === '' || this.props.invoiceURL === null || this.props.invoiceURL === undefined;
    var containerStyle = {
      height: '50px',
      width: '100%',
      maxWidth: '300px',
      overflow: 'hidden',
      borderRadius: '10px'
    };
    var buttonStyle = {
      backgroundColor: this.state.buttonHover && !loading ? '#444' : '#f7cc5c',
      height: '50px',
      width: '100%',
      maxWidth: '300px',
      display: 'flex',
      flexDirection: 'row',
      alignItems: 'center',
      justifyContent: 'center',
      borderRadius: '10px'
    };
    var imgStyle = {
      height: '20px',
      margin: '10px'
    };
    var h1Style = {
      lineHeight: '20px',
      fontSize: '25px',
      display: 'block',
      fontFamily: 'Inconsolata',
      color: this.state.buttonHover && !loading ? '#fff' : '#444',
      marginRight: this.state.discount ? '40px' : '0'
    };
    var loaderStyle = {
      zIndex: 100
    };
    var overlayStyle = {
      position: 'relative',
      backgroundColor: 'red',
      top: '-36px',
      left: '178px',
      textAlign: 'center',
      color: '#FFF',
      fontWeight: 'bold',
      fontSize: '16px',
      width: '150px',
      transform: 'rotate(30deg)'
    };
    return /*#__PURE__*/React__default.createElement("div", {
      style: containerStyle
    }, /*#__PURE__*/React__default.createElement("style", null, "@import url('https://fonts.googleapis.com/css2?family=Inconsolata:wght@600&display=swap');"), /*#__PURE__*/React__default.createElement("div", {
      style: buttonStyle,
      onClick: this.goToInvoice,
      onMouseEnter: function onMouseEnter() {
        return _this2.setState({
          buttonHover: true
        });
      },
      onMouseLeave: function onMouseLeave() {
        return _this2.setState({
          buttonHover: false
        });
      }
    }, loading ? /*#__PURE__*/React__default.createElement("div", {
      style: loaderStyle
    }, /*#__PURE__*/React__default.createElement(Loader, {
      type: "ThreeDots",
      color: "#444",
      height: 40,
      width: 80
    })) : null, loading ? null : /*#__PURE__*/React__default.createElement("img", {
      style: imgStyle,
      src: this.state.buttonHover ? 'https://www.senddots.com/img/logo.png' : 'https://www.senddots.com/img/logo_dark.png',
      alt: "dots logo"
    }), loading ? null : /*#__PURE__*/React__default.createElement("span", {
      style: h1Style
    }, this.props.buttonVerb ? this.props.buttonVerb : 'Pay', " with Dots")), this.state.discount ? /*#__PURE__*/React__default.createElement("div", {
      style: overlayStyle
    }, "DISCOUNT") : null);
  };

  return DotsCheckout;
}(React.Component);

module.exports = DotsCheckout;
//# sourceMappingURL=index.js.map
